#include "zpfft.h"

struct {
  int size;
  void (*fft)(const zpfft_p *,double *);
  void (*fft_un)(const zpfft_p *,double *);
  double zeta;
} todo[] = {
  2, zpfft_2, zpfft_un2, -1.0
, 4, zpfft_4, zpfft_un4, 911673634.0
, 8, zpfft_8, zpfft_un8, 1550788396.0
, 16, zpfft_16, zpfft_un16, 483614631.0
, 32, zpfft_32, zpfft_un32, 324124180.0
, 64, zpfft_64, zpfft_un64, 261042355.0
, 128, zpfft_128, zpfft_un128, 1713944545.0
, 256, zpfft_256, zpfft_un256, 1076760042.0
, 512, zpfft_512, zpfft_un512, 29975329.0
, 1024, zpfft_1024, zpfft_un1024, 139774242.0
, 2048, zpfft_2048, zpfft_un2048, 816757248.0
, 4096, zpfft_4096, zpfft_un4096, 982536152.0
, 8192, zpfft_8192, zpfft_un8192, 58019078.0
, 16384, zpfft_16384, zpfft_un16384, 141672340.0
, 32768, zpfft_32768, zpfft_un32768, 865195252.0
, 65536, zpfft_65536, zpfft_un65536, 23386068.0
, 131072, zpfft_131072, zpfft_un131072, 176122724.0
, 262144, zpfft_262144, zpfft_un262144, 111412671.0
, 524288, zpfft_524288, zpfft_un524288, 420538333.0
, 1048576, zpfft_1048576, zpfft_un1048576, 406741685.0
};

main()
{
  zpfft_p *c;
  double *u;
  double *r;
  double expected;
  double received;
  int i;
  int k;

  asm volatile("fldcw %0"::"m"(0x137f));

  c = (zpfft_p *) malloc(sizeof *c);
  if (!c) exit(111);

  u = (double *) malloc(1048576 * sizeof(double));
  if (!u) exit(111);

  r = (double *) malloc(1048576 * sizeof(double));
  if (!r) exit(111);

  zpfft_init(c,2113929217.0,406741685.0);

  for (i = 0;i < sizeof(todo)/sizeof(*todo);++i) {
    for (k = 0;k < todo[i].size;++k)
      r[k] = -1073741824.0 + random();
    for (k = 0;k < todo[i].size;++k)
      u[k] = r[k];

    todo[i].fft(c,u);
    todo[i].fft_un(c,u);

    for (k = 0;k < todo[i].size;++k) {
      received = zpfft_product(c,u[k],1);
      expected = zpfft_product(c,r[k],todo[i].size);
      if (received != expected)
	printf("mismatch! %d %d %f %f\n",todo[i].size,k,received,expected);
    }
  }

  exit(0);
}
