#ifndef ZPFFT_H
#define ZPFFT_H "pentium"

typedef struct {
  double p;
  double pinv;
  double alpha0;
  double zeta[13];
  double zetainv[13];
  double roots[257];
} zpfft_p;

extern void zpfft_init(zpfft_p *,double,double);

extern double zpfft_product(zpfft_p *,double,double);

extern void zpfft_2(const zpfft_p *,double *);
extern void zpfft_4(const zpfft_p *,double *);
extern void zpfft_8(const zpfft_p *,double *);
extern void zpfft_16(const zpfft_p *,double *);
extern void zpfft_32(const zpfft_p *,double *);
extern void zpfft_64(const zpfft_p *,double *);
extern void zpfft_128(const zpfft_p *,double *);
extern void zpfft_256(const zpfft_p *,double *);
extern void zpfft_512(const zpfft_p *,double *);
extern void zpfft_1024(const zpfft_p *,double *);
extern void zpfft_2048(const zpfft_p *,double *);
extern void zpfft_4096(const zpfft_p *,double *);
extern void zpfft_8192(const zpfft_p *,double *);
extern void zpfft_16384(const zpfft_p *,double *);
extern void zpfft_32768(const zpfft_p *,double *);
extern void zpfft_65536(const zpfft_p *,double *);
extern void zpfft_131072(const zpfft_p *,double *);
extern void zpfft_262144(const zpfft_p *,double *);
extern void zpfft_524288(const zpfft_p *,double *);
extern void zpfft_1048576(const zpfft_p *,double *);

#define zpfft_un2 zpfft_2
extern void zpfft_un4(const zpfft_p *,double *);
extern void zpfft_un8(const zpfft_p *,double *);
extern void zpfft_un16(const zpfft_p *,double *);
extern void zpfft_un32(const zpfft_p *,double *);
extern void zpfft_un64(const zpfft_p *,double *);
extern void zpfft_un128(const zpfft_p *,double *);
extern void zpfft_un256(const zpfft_p *,double *);
extern void zpfft_un512(const zpfft_p *,double *);
extern void zpfft_un1024(const zpfft_p *,double *);
extern void zpfft_un2048(const zpfft_p *,double *);
extern void zpfft_un4096(const zpfft_p *,double *);
extern void zpfft_un8192(const zpfft_p *,double *);
extern void zpfft_un16384(const zpfft_p *,double *);
extern void zpfft_un32768(const zpfft_p *,double *);
extern void zpfft_un65536(const zpfft_p *,double *);
extern void zpfft_un131072(const zpfft_p *,double *);
extern void zpfft_un262144(const zpfft_p *,double *);
extern void zpfft_un524288(const zpfft_p *,double *);
extern void zpfft_un1048576(const zpfft_p *,double *);

#endif
