#include "zpfft.h"
#include "timing.h"

static timing start;
static timing_basic startb;
static timing finish;
static timing_basic finishb;

#define TIMINGS 7
static timing t[20][TIMINGS + 1];
static timing t2[20][TIMINGS + 1];
static timing tnothing[TIMINGS + 1];
static timing tinit[TIMINGS + 1];

main()
{
  zpfft_p *c;
  double *u;
  int i;
  double diff;

  asm volatile("fldcw %0"::"m"(0x137f));

  c = (zpfft_p *) malloc(sizeof *c);
  if (!c) exit(111);

  u = (double *) malloc(262144 * sizeof(double));
  if (!u) exit(111);

  for (i = 0;i < 262144;++i)
    u[i] = i;

  timing_basic_now(&startb);
  timing_now(&start);

  timing_now(&tnothing[0]);
  for (i = 1;i <= TIMINGS;++i) {
    timing_now(&tnothing[i]);
  }

#define TIME(what,x) \
  timing_now(&x[0]); for (i = 1;i <= TIMINGS;++i) { what; timing_now(&x[i]); }

  TIME(zpfft_init(c,2113929217.0,406741685.0),tinit)
  TIME(zpfft_2(c,u),t[0])
  TIME(zpfft_4(c,u),t[1])
  TIME(zpfft_8(c,u),t[2])
  TIME(zpfft_16(c,u),t[3])
  TIME(zpfft_32(c,u),t[4])
  TIME(zpfft_64(c,u),t[5])
  TIME(zpfft_128(c,u),t[6])
  TIME(zpfft_256(c,u),t[7])
  TIME(zpfft_512(c,u),t[8])
  TIME(zpfft_1024(c,u),t[9])
  TIME(zpfft_2048(c,u),t[10])
  TIME(zpfft_4096(c,u),t[11])
  TIME(zpfft_8192(c,u),t[12])
  TIME(zpfft_16384(c,u),t[13])
  TIME(zpfft_32768(c,u),t[14])
  TIME(zpfft_65536(c,u),t[15])
  TIME(zpfft_131072(c,u),t[16])
  TIME(zpfft_262144(c,u),t[17])
  TIME(zpfft_un2(c,u),t2[0])
  TIME(zpfft_un4(c,u),t2[1])
  TIME(zpfft_un8(c,u),t2[2])
  TIME(zpfft_un16(c,u),t2[3])
  TIME(zpfft_un32(c,u),t2[4])
  TIME(zpfft_un64(c,u),t2[5])
  TIME(zpfft_un128(c,u),t2[6])
  TIME(zpfft_un256(c,u),t2[7])
  TIME(zpfft_un512(c,u),t2[8])
  TIME(zpfft_un1024(c,u),t2[9])
  TIME(zpfft_un2048(c,u),t2[10])
  TIME(zpfft_un4096(c,u),t2[11])
  TIME(zpfft_un8192(c,u),t2[12])
  TIME(zpfft_un16384(c,u),t2[13])
  TIME(zpfft_un32768(c,u),t2[14])
  TIME(zpfft_un65536(c,u),t2[15])
  TIME(zpfft_un131072(c,u),t2[16])
  TIME(zpfft_un262144(c,u),t2[17])

  timing_basic_now(&finishb);
  timing_now(&finish);


  printf("Using");
#ifdef HASRDTSC
  printf(" RDTSC,");
#else
#ifdef HASGETHRTIME
  printf(" gethrtime(),");
#endif
#ifdef HASRPCC
  printf(" rpcc(),");
#endif
#endif
  printf(" %s/*.c.\n",ZPFFT_H);


#define PRINT(label,x) \
  printf(label); \
  for (i = 0;i < TIMINGS;++i) { \
    diff = timing_diff(&x[i + 1],&x[i]); \
    printf(" %9.0f",diff); \
  } \
  printf("\n");

  PRINT("empty   ",tnothing)
  PRINT("init    ",tinit)
  PRINT("2+      ",t[0])
  PRINT("2-      ",t2[0])
  PRINT("4+      ",t[1])
  PRINT("4-      ",t2[1])
  PRINT("8+      ",t[2])
  PRINT("8-      ",t2[2])
  PRINT("16+     ",t[3])
  PRINT("16-     ",t2[3])
  PRINT("32+     ",t[4])
  PRINT("32-     ",t2[4])
  PRINT("64+     ",t[5])
  PRINT("64-     ",t2[5])
  PRINT("128+    ",t[6])
  PRINT("128-    ",t2[6])
  PRINT("256+    ",t[7])
  PRINT("256-    ",t2[7])
  PRINT("512+    ",t[8])
  PRINT("512-    ",t2[8])
  PRINT("1024+   ",t[9])
  PRINT("1024-   ",t2[9])
  PRINT("2048+   ",t[10])
  PRINT("2048-   ",t2[10])
  PRINT("4096+   ",t[11])
  PRINT("4096-   ",t2[11])
  PRINT("8192+   ",t[12])
  PRINT("8192-   ",t2[12])
  PRINT("16384+  ",t[13])
  PRINT("16384-  ",t2[13])
  PRINT("32768+  ",t[14])
  PRINT("32768-  ",t2[14])
  PRINT("65536+  ",t[15])
  PRINT("65536-  ",t2[15])
  PRINT("131072+ ",t[16])
  PRINT("131072- ",t2[16])
  PRINT("262144+ ",t[17])
  PRINT("262144- ",t2[17])

  printf("Timings are in ticks. Nanoseconds per tick: approximately %f.\n"
    ,timing_basic_diff(&finishb,&startb) / timing_diff(&finish,&start));
  printf("Timings may be underestimates on systems without hardware tick support.\n");

  exit(0);
}
